<?php
/**
 * @package     WT JSwiper
 * @copyright   (C) 2023 Sergey Tolkachyov <https://web-tolk.ru>
 * @link 		https://web-tolk.ru/dev/joomla-plugins/wt-jswiper.html
 * @license     GNU General Public License version 3 or later
 */

defined('_JEXEC') or die;

use Joomla\CMS\Application\CMSApplicationInterface;
use Joomla\CMS\Factory;
use Joomla\String\StringHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Utility\Utility;
use Joomla\Event\SubscriberInterface;


class PlgContentWthighlightjs extends CMSPlugin
//    implements SubscriberInterface
{
    /**
     * Load the language file on instantiation.
     *
     * @var    boolean
     *
     * @since  3.9.0
     */
    protected $autoloadLanguage = true;

    /**
     * @inheritDoc
     *
     * @return string[]
     *
     * @throws Exception
     * @since 4.1.0
     *
     */
//    public static function getSubscribedEvents(): array
//    {
//        $app = Factory::getApplication();
//
//        $mapping = [];
//
//        if ($app->isClient('site')) {
//            $mapping['onContentPrepare'] = 'onContentPrepare';
//
//        }
//
//        return $mapping;
//    }


    /**
     * Plugin that adds a pagebreak into the text and truncates text at that point
     *
     * @param string $context The context of the content being passed to the plugin.
     * @param object   &$row The article object.  Note $article->text is also available
     * @param mixed    &$params The article params
     * @param integer $page The 'page' number
     *
     * @return  void
     *
     * @since   1.6
     */
    public function onContentPrepare($context, &$row, &$params, $page = 0)
    {
        // Expression to search for.
        $regex = '#<pre><code class="language-(.*)"\/?>#iU';

//        // Simple performance check to determine whether bot should process further.
//        if (StringHelper::strpos($row->text, 'class="system-pagebreak') === false) {
//            if ($page > 0) {
//                throw new Exception(Text::_('JERROR_PAGE_NOT_FOUND'), 404);
//            }
//
//            return;
//        }

        // Find all instances of plugin and put in $matches.
        $matches = [];
        preg_match_all($regex, $row->text, $matches, PREG_SET_ORDER);


        if(count($matches) > 0)
        {
            $app = Factory::getApplication();
            /** @var Joomla\CMS\WebAsset\WebAssetManager $wa */
            $wa = $app->getDocument()->getWebAssetManager();

            $wa->registerAndUseScript('highlight.js', 'plg_content_wthighlightjs/highlight.js');
            if($this->params->get('color_scheme_type','default') == 'base16'){
                $color_scheme = $this->params->get('color_scheme_base16','colors.min.css');
                $wa->registerAndUseStyle('highlight.js','media/plg_content_wthighlightjs/css/base16/'.$color_scheme);
            } else{
                $color_scheme = $this->params->get('color_scheme','default.min.css');
                $wa->registerAndUseStyle('highlight.js','plg_content_wthighlightjs/'.$color_scheme);
            }

            foreach ($matches as $match){
                $lang = $match[1];

                $wa->registerAndUseScript('highlight.js.'.$lang, 'media/plg_content_wthighlightjs/js/languages/'.$lang.'.min.js');
                // media/plg_content_wthighlightjs/js/languages
            }

            $wa->addInlineScript('hljs.highlightAll();');

        }

        // Split the text around the plugin.



    }
}
